ICU 71.1: icu::UCharsTrieBuilder Class Reference

ICU 71.1 71.1

Data Structures | Public Member Functions
icu::UCharsTrieBuilder Class Reference

Builder class for UCharsTrie. More...

`#include <ucharstriebuilder.h>`

Inheritance diagram for icu::UCharsTrieBuilder:

## Public Member Functions
| UCharsTrieBuilder (UErrorCode &errorCode)
| Constructs an empty builder. More...
virtual | ~UCharsTrieBuilder ()
| Destructor. More...
UCharsTrieBuilder & | add (const UnicodeString &s, int32_t value, UErrorCode &errorCode)
| Adds a (string, value) pair. More...
UCharsTrie * | build (UStringTrieBuildOption buildOption, UErrorCode &errorCode)
| Builds a UCharsTrie for the add()ed data. More...
UnicodeString & | buildUnicodeString (UStringTrieBuildOption buildOption, UnicodeString &result, UErrorCode &errorCode)
| Builds a UCharsTrie for the add()ed data and char16_t-serializes it. More...
UCharsTrieBuilder & | clear ()
| Removes all (string, value) pairs. More...

## Detailed Description

Builder class for UCharsTrie.

This class is not intended for public subclassing.

Stable:
  ICU 4.8

Definition at line 43 of file ucharstriebuilder.h.

## Constructor & Destructor Documentation

## ◆ UCharsTrieBuilder()

icu::UCharsTrieBuilder::UCharsTrieBuilder | ( | UErrorCode & | errorCode | ) |

Constructs an empty builder.

Parameters

  errorCode | Standard ICU error code.

Stable:
  ICU 4.8

## ◆ ~UCharsTrieBuilder()

virtual icu::UCharsTrieBuilder::~UCharsTrieBuilder | ( |  | ) |
| virtual

Destructor.

Stable:
  ICU 4.8

## Member Function Documentation

## ◆ add()

UCharsTrieBuilder & icu::UCharsTrieBuilder::add | ( | const UnicodeString & | s,
|  | int32_t | value,
|  | UErrorCode & | errorCode
| ) |  |

Adds a (string, value) pair.

The string must be unique. The string contents will be copied; the builder does not keep a reference to the input UnicodeString or its buffer.

Parameters

  s | The input string.
  value | The value associated with this string.
  errorCode | Standard ICU error code. Its input value must pass the U_SUCCESS() test, or else the function returns immediately. Check for U_FAILURE() on output or use with function chaining. (See User Guide for details.)

Returns
  *this

Stable:
  ICU 4.8

## ◆ build()

UCharsTrie * icu::UCharsTrieBuilder::build | ( | UStringTrieBuildOption | buildOption,
|  | UErrorCode & | errorCode
| ) |  |

Builds a UCharsTrie for the add()ed data.

Once built, no further data can be add()ed until clear() is called.

A UCharsTrie cannot be empty. At least one (string, value) pair must have been add()ed.

This method passes ownership of the builder's internal result array to the new trie object. Another call to any build() variant will re-serialize the trie. After clear() has been called, a new array will be used as well.

Parameters

  buildOption | Build option, see UStringTrieBuildOption.
  errorCode | Standard ICU error code. Its input value must pass the U_SUCCESS() test, or else the function returns immediately. Check for U_FAILURE() on output or use with function chaining. (See User Guide for details.)

Returns
  A new UCharsTrie for the add()ed data.

Stable:
  ICU 4.8

## ◆ buildUnicodeString()

UnicodeString & icu::UCharsTrieBuilder::buildUnicodeString | ( | UStringTrieBuildOption | buildOption,
|  | UnicodeString & | result,
|  | UErrorCode & | errorCode
| ) |  |

Builds a UCharsTrie for the add()ed data and char16_t-serializes it.

Once built, no further data can be add()ed until clear() is called.

A UCharsTrie cannot be empty. At least one (string, value) pair must have been add()ed.

Multiple calls to buildUnicodeString() set the UnicodeStrings to the builder's same char16_t array, without rebuilding. If buildUnicodeString() is called after build(), the trie will be re-serialized into a new array (because build() passes on ownership). If build() is called after buildUnicodeString(), the trie object returned by build() will become the owner of the underlying data for the previously returned UnicodeString. After clear() has been called, a new array will be used as well.

Parameters

  buildOption | Build option, see UStringTrieBuildOption.
  result | A UnicodeString which will be set to the char16_t-serialized UCharsTrie for the add()ed data.
  errorCode | Standard ICU error code. Its input value must pass the U_SUCCESS() test, or else the function returns immediately. Check for U_FAILURE() on output or use with function chaining. (See User Guide for details.)

Returns
  result

Stable:
  ICU 4.8

## ◆ clear()

UCharsTrieBuilder & icu::UCharsTrieBuilder::clear | ( |  | ) |
| inline

Removes all (string, value) pairs.

New data can then be add()ed and a new trie can be built.

Returns
  *this

Stable:
  ICU 4.8

Definition at line 128 of file ucharstriebuilder.h.

The documentation for this class was generated from the following file:

- ucharstriebuilder.h